!*********************************************
!*
!* Main program for the TP about FFT-radix4
!*
!********************************************

PROGRAM program

  !* modules loaded

  USE constants

  USE dft_module
  
  USE fft_module

  IMPLICIT NONE

  !* Variable declarations

  COMPLEX(idp), DIMENSION(:), ALLOCATABLE :: x,y
  INTEGER :: i,n
  REAL(idp) :: pi

  !* Constants definition

  pi= 4.d0*atan(1.d0)

  Write(*,*) 'Quelle taille pour le systeme?'
  Read(*,*) n

  !* Memory allocation

  allocate(x(n),y(n))
  
  !* Initialization of the vector

  call init_Vector(x)

  write(*,*) 'x'

  write(*,10) x

  !* Computation of the Fourier transform
  !* with the fft radix-2

  call fft_radix_2(x,y,FORWARD)
  
  write(*,*) 'y with fft'
  write(*,10) y
  y=CMPLX(0.d0,0.d0)

  !* Computation of the Fourier transform
  !* with the classical dft

  call dft(x,y,FORWARD)
  write(*,*) 'y with dft'
  write(*,10) y
  10 FORMAT(2E14.6)

  !* Memory deallocation

  deallocate(x,y)

  contains


    !****************************************
    !*
    !* Subroutine for the initialization of
    !* the vector to transform
    !*
    !* INPUT
    !*
    !* x :: vector to initialize
    !*
    !****************************************
    SUBROUTINE init_Vector(x)

      !* Variable declarions
      COMPLEX(idp), DIMENSION(:) :: x

      INTEGER :: i,n

      !* Code

      n=size(x,1)

      DO i=1,n
         x(i) = cos(2*pi*REAL(i-1)/REAL(n-1))
      END DO
      
    END SUBROUTINE init_Vector

END PROGRAM program
